
/*函数的使用说明：
1.该twi模块包含四种工作模式，主发，主收，从收，从发，其中主发由
  twiWriteByte(从机地址，要发送的数据)实现，主收由twiReadByte(从机地址)实现，从机
  的发送与接收均通过中断实现
2.在从机模式下，需调用twi_init()来使能并初始化twi总线
3.在主机模式下，调用twiWriteByte(从机地址，要发送的数据）向指定的从机写入数据，
  调用twiReadByte(从机地址)从指定的从机读取数据，然后可通过查询错误状态error_state
  的值决定下一步如何操作。
*/

//************************* 头文件 ******************************************
#include "twi.h"

//TWI同程序的接口参数
//receive_data,error_state不用设置
extern int receive_data;  		 // 接收到的数据
extern char error_state;   		 // twi错误状态
//以下三个参数根据需求进行设置
extern char slave_address;      // 设置从机地址，Bits 7..1:存放从机地址，Bit 0：最低位为广播识别使能位
extern char bit_race;           // 设置主机模式的比特率，SCL=CPU频率/(16+2*(TWBR)*4TWPS),TWPS在4的指数位置
extern int send_data;     	    // 从机发送模式下从机向主机发送的数据
extern char receiveflag;
//*************************** twi错误状态说明*********************************
// 0：twi传送无错误
// 1：在主发模式下，SLA+W已发送，返回NOT ACK
// 2：在主发模式下，DATA已发送，返回NOT ACK
// 3：在主发模式下，SLA+W或者数据的仲裁失败
// 4：在主收模式下，SLA+R或者数据的仲裁失败
// 5：在主收模式下，SLA+R已发送，返回NOT ACK
// 6：在主发模式下，START信号发送时等待超时
// 7：在主收模式下，START信号发送时等待超时
// 8：在主收模式下，数据接受完成
// 9：在主收模式下，数据接受不成功
// 10:在主发模式下，数据或地址发送时等待超时，强制退出总线
//*****************************************************************************

//*************************** twi stop 信号延时时间 ****************************
//******************************************************************************
void StopDelay(void)
{
	unsigned int i;
	for(i = 0;i < 1400 ;i ++);
}
//******************************* twi 启动总线*********************************
//******************************************************************************
void start(void)
{
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);	//发出start信号
	_NOP();
	_NOP();
}
//************************** twi 释放总线************************************
//***************************************************************************
void stop(void)
{
	TWCR = (1 << TWINT) |(1 << TWEN)|(1 << TWSTO); //发出stop信号	
	TWCR= 0x45;
	StopDelay();           //等待总线恢复
}
//****************************** twi 初始化*************************************
// TWCR: 控制寄存器，用来控制TWI操作，说明如下：
// Bit 7-TWINT：中断标志位，Bit 6-TWEA：使能应答位，Bit 5-TWSTA：START状态位
// Bit 4-TWSTO：STOP状态位，Bit 3-TWWC: 写冲突标志，Bit 2-TWEN：TWI使能位
// Bit 1-RES：保留，Bit 0-TWIE：中断使能                   
// TWSR: 状态寄存器，Bits 7..3:表示了TWI总线的当前状态，读取时需屏蔽低三位的值，Bits 1..0-TWPS:TWI预分频位
// TWBR: 比特率寄存器，用来设置TWI的工作频率，计算公式为：SCL=CPU频率/(16+2*(TWBR)*4TWPS),TWPS在4的指数位置
// TWAR: 从机地址寄存器，Bits 7..1:存放从机地址，Bit 0：最低位为广播识别使能位
// TWDR: 数据寄存器，用来存放接收或要发送的地址和数据
//******************************************************************************
void twi_init(void)
{
	TWCR= 0x00;    			//disable twi
	TWBR= bit_race;   		//set bit rate
	TWSR= 0x00;             //set prescale为1
	TWAR= slave_address;    //set slave address
	TWCR= 0x45;          //enable twi
}
//************************** 检测发送时的状态码 ****************************
//**************************************************************************
void checkstate(void)
{
	unsigned char TWSR_state;
	TWSR_state = TWSR & 0xf8; //屏蔽第三位读取状态
	switch(TWSR_state)
	{
	//case 0x08:error_state=0;break;  // START已发送
	//case 0x18:error_state=0;break;  // SLA+W已发送，接收到ACK
	case 0x20:error_state=1;break;  // SLA+W已发送，接收到NOT ACK
	//case 0x28:error_state=0;break;  // 数据已发送，接收到ACK
	case 0x30:error_state=2;break;  // 数据已发送，接收到NOT ACK
	case 0x38:error_state=3;break;  // SLA+W或数据的仲裁失败
	default: break;
	}
	TWCR=0x45;
}
//********** twi主机发送，向地址为WriteAddress的从机发送1个字节数据************
// 入口参数1：WriteAddress：从机地址
// TWDR中存放的高七位为地址，最低位表示读写控制，0为写，1为读
// 入口参数2：data，向从机写的数据
//******************************************************************************
void twiWriteByte(unsigned char WriteAddress,char data)
{
	unsigned char TWCR_state;
	char i=0;
	error_state=0;
	
	//初始化 twi 
	twi_init();
	
	//发送START信号 
	start();
	while((TWCR & 0x80) == 0x00)
	{
		if(i++==20){error_state=6;break;}
	}	
	
	//若START发送成功，发送从机地址
	i=0;
	if(error_state==0)
	{
		TWDR = WriteAddress;        //发地址
		TWCR = (1 << TWINT) | (1 << TWEN);
		while((TWCR & 0x80) == 0x00)
		{ 
		  if(i++==200){error_state=10;break;}
		}	
		checkstate();
	}
	
	//若从机地址发送成功，向从机发送数据
	i=0;
	if(error_state==0)
	{
	
		TWDR = data;               //发数据
		TWCR = (1 << TWINT) | (1 << TWEN);
		while((TWCR & 0x80) == 0x00)
		{ 
		  if(i++==200){error_state=10;break;}
		}	
		checkstate();
	}
	//发送STOP，退出总线控制
	if(error_state==0) stop();
	else if(error_state==6){}
	else {stop();TWCR=0x00;TWCR==0x45;}
}
//************** twi主机接收，从地址为ReadAaddress的从机接收1个字节*************
// 入口参数1：ReadAaddress：从机地址
// TWDR中存放的高七位为地址，最低位表示读写控制，0为写，1为读
//******************************************************************************
void twiReadByte(unsigned char ReadAaddress)
{
	unsigned char TWCR_state;
	char i=0;
	error_state=0;
	
	//初始化 twi 
	twi_init();
	
	//发送START信号
	start();
	while((TWCR & 0x80) == 0x00)
		{ 
		  if(i++==20){error_state=7;break;}
		}	
	
	//若START信号发送完成，发送读地址，并读取数据
	if(error_state==0)
	{
		TWDR = ReadAaddress;         //发地址
		TWCR = (1 << TWINT) | (1 << TWEN)|( 1<<TWIE )|(1 << TWEA);
		while(error_state==0) 
		{if(i++==200){error_state=9;break;}};
	}
	
	//发送STOP，退出总线控制
	if(error_state==0) stop();
	else if(error_state==6){}
	else {stop();TWCR=0x00;TWCR==0x45;}
}
//************** twi 中断例程，接收数据 ****************************************
//******************************************************************************
//twi中断服务程序
char twi_isr(void)
{
	unsigned char TWSR_state;
	TWSR_state = TWSR & 0xf8;
	//USART_Transmit(TWSR_state);
	switch(TWSR_state)
	{
		//从机接收模式下的中断程序
    case 0x60: TWCR=0xc5;break;      	       // SLA+W已经接收，ACK已返回（从机被寻址，等待主机发送数据）
    case 0x80: receive_data = TWDR;TWCR=0xc5;receiveflag=1;break;  // 数据已接收，ACK已返回（接收数据）
    case 0x88: TWCR=0xc5;break;			       // 数据已接收，NOT ACK已返回（下一步：退出总线）
	case 0xA0: TWCR=0xc5;break;			       // 接收到STOP或重复的START信号（停止接收数据）
		
		//主机接收模式下的中断程序
    case 0x38: error_state=4;TWCR=0xc5;break;  // SLA+R或NOT ACK仲裁失败（下一步：退出总线）
	case 0x40: TWCR=0x85; break;               // SLA+R已发送，接收到ACK（从机被寻址，主机等待接收数据）
	case 0x48: error_state=5;TWCR=0xc5;break;  // SLA+R已发送，接收到NOT ACK（下一步：退出总线）
    case 0x50: receive_data = TWDR;_NOP();_NOP();error_state=8;TWCR = 0xc5;break;	// 接收到数据，ACK已返回（接收数据）
	case 0x58: receive_data = TWDR;_NOP();_NOP();error_state=8;TWCR = 0x95;break;   // 接收到数据，NOT ACK已返回（下一步：退出总线）
		
		//从机发送模式
	case 0xA8: TWDR= send_data;_NOP();_NOP();TWCR= 0x85; break; // SLA+R已接收，ACK已返回（从机被寻址，开送发送数据）
	case 0xB8: TWCR= 0xc5;break;              // TWDR里的数据已发送，接受到ACK（主机接收到数据，继续发送数据）
	case 0xC0: TWCR= 0xc5;break;			  // TWDR里的数据已发送，接受到NOT ACK（下一步：退出总线）
	case 0xC8: TWCR= 0xc5;break;              // TWEA=0,接收到ACK（停止发送数据，退出发送）
		
		//其他状态码
	case 0xf8: break;						  // 等待或进行当前传输
	case 0x00: TWCR= 0x95;break;              // 非法的START或STOP引起的总线错误（释放总线）
    default:   break;
	}
	//if(TWSR_state==0xA0)
	//USART_Transmit(receive_data);
	return receive_data;					  // 返回接收到的数据
}